<?php
    if(!empty($_SERVER['HTTP_USER_AGENT'])){
        session_name(md5($_SERVER['HTTP_USER_AGENT']));
    }
    session_start();
    require_once('../api/Okay.php');
    define('IS_CLIENT', true);
    $okay = new Okay();
    $limit = 10;

    /*Определяем язык*/
    $lang_id  = $okay->languages->lang_id();
    $language = $okay->languages->get_language($lang_id);
    $lang_link = $okay->languages->get_lang_link();
    /*vedastudio_category_search*/
    $c_px = ($lang_id ? 'l' : 'c'); /*Если язык существует выбираем с таблицы переводов, иначе - таблицы categories*/
    $c_lang_sql = $okay->languages->get_query(array('object'=>'category'));
    /*/vedastudio_category_search*/
    $px = ($lang_id ? 'l' : 'p'); /*Если язык существует выбираем с таблицы переводов, иначе - таблицы produtcs*/
    $lang_sql = $okay->languages->get_query(array('object'=>'product'));

    /*Ищем товар*/
    $keyword = $okay->request->get('query', 'string');
    /*vedastudio_category_search*/
    $keyword_category_filter = '';
    /*/vedastudio_category_search*/
    $keyword_filter = '';
    if (!empty($keyword)) {
        $keywords = explode(' ', $keyword);
        foreach ($keywords as $kw) {
            $kw = $okay->db->escape($kw);
            if($kw!=='') {
                $keyword_filter .= $okay->db->placehold("AND (
                        $px.name LIKE '%$kw%'
                        OR $px.meta_keywords LIKE '%$kw%'
                        OR p.id in (SELECT product_id FROM __variants WHERE sku LIKE '%$kw%')
                    ) ");
                /*vedastudio_category_search*/
                $keyword_category_filter .= $okay->db->placehold("AND (
                       $c_px.name LIKE '%$kw%'
                    ) ");
                /*/vedastudio_category_search*/
            }
        }
    }

    /*vedastudio_category_search*/
    /*Делаем выборку из БД*/
    $okay->db->query("SELECT 
                    c.id,
                    c.url,
                    $c_px.name, 
                    c.image 
                FROM __categories c
                $c_lang_sql->join 
                WHERE 
                    1
                    $keyword_category_filter
                    AND visible=1
                    GROUP BY c.id
                ORDER BY $c_px.name 
                LIMIT ?
            ", $limit);
    $categories = $okay->db->results();

    $categories_suggestions = array();
    /*Подготавливаем данные для отображения в автокомплите*/
    foreach($categories as $category) {
        $c_suggestion = new stdClass();
        if(!empty($category->image)) {
            $category->image = $okay->design->resize_modifier($category->image, 35, 35, false, $okay->config->resized_categories_dir);
        }
        $c_suggestion->type = 'category';
        $c_suggestion->price = 0;
        $c_suggestion->currency = $currency->sign;
        $c_suggestion->value = $category->name;
        $c_suggestion->data = $category;
        $c_suggestion->lang = $lang_link;
        $categories_suggestions[] = $c_suggestion;
    }

    /*/vedastudio_category_search*/
    /*Делаем выборку из БД*/
	$okay->db->query("SELECT 
            p.id,
            p.url,
            p.main_image_id,
            $px.name
        FROM __products p 
        $lang_sql->join
        WHERE 
            1
            $keyword_filter
            AND visible=1
        ORDER BY $px.name 
        LIMIT ?
    ", $limit);
    $products = $okay->db->results();

    /*vedastudio_category_search*//*$suggestions = array();*/$products_suggestions = array();/*/vedastudio_category_search*/
    $ids = array();
    $images_ids = array();
    foreach($products as $p){
        $ids[] = $p->id;
        $images_ids[] = $p->main_image_id;
    }
    /*Подставляем к найденым товарам их варианты*/
    $variants = array();
    foreach ($okay->variants->get_variants(array('product_id'=>$ids)) as $v) {
        $variants[$v->product_id][] = $v;
    }

    /*Картинки товаров*/
    $images = array();
    if (!empty($images_ids)) {
        foreach ($okay->products->get_images(array('id'=>$images_ids)) as $i) {
            $images[$i->product_id] = $i->filename;
        }
    }

    /*Определяем валюту*/
    $currencies = $okay->money->get_currencies(array('enabled'=>1));
    if(isset($_SESSION['currency_id'])) {
        $currency = $okay->money->get_currency($_SESSION['currency_id']);
    } else {
        $currency = reset($currencies);
    }

    /*Подготавливаем данные для отображения в автокомплите*/
    foreach($products as $product) {
        $suggestion = new stdClass();
        if(isset($images[$product->id])) {
            $product->image = $okay->design->resize_modifier($images[$product->id], 35, 35);
        }
        /*vedastudio_category_search*/
        $suggestion->type = 'product';
        /*/vedastudio_category_search*/
        $suggestion->price = $okay->money->convert($variants[$product->id][0]->price, $currency->id);
        $suggestion->currency = $currency->sign;
        $suggestion->value = $product->name;
        $suggestion->data = $product;
        $suggestion->lang = $lang_link;
        /*vedastudio_category_search*//*$suggestions[] = $suggestion;*/$products_suggestions[] = $suggestion;/*/vedastudio_category_search*/
    }
    /*vedastudio_category_search*/
    $suggestions = array_merge($categories_suggestions,$products_suggestions);
    /*/vedastudio_category_search*/

    $res = new stdClass;
    $res->query = $keyword;
    $res->suggestions = $suggestions;
    header("Content-type: application/json; charset=UTF-8");
    header("Cache-Control: must-revalidate");
    header("Pragma: no-cache");
    header("Expires: -1");		
    print json_encode($res);
